import controlP5.*;

void setup() {
  size(400, 400);
  PFont pfont = createFont("Arial", 12, true); 
  ControlFont font = new ControlFont(pfont, 14);
  ControlP5 cp5 = new ControlP5(this); 
  DropdownList d1;

  cp5.addSlider("Wert")
    .setFont(font) 
    .setRange(0.1, 3) //Zahlenbereich
    .setPosition(20, 50)
    .setSize(150, 20)
    //Vordergrundfarbe des Sliders:
    .setColorForeground(color(0, 0, 60))
    //Vordergrundfarbe des Sliders aktiv:
    .setColorActive(color(80))
    //Hintergrundfarbe des Sliders:
    .setColorBackground(color(150))   
    //Farbe der Beschriftung außerhalb:
    .setColorLabel(color(0)) 
    //Farbe der Beschriftung innerhalb:
    .setColorValue(color(255)); 

  cp5.addButton("Button1")
    .setPosition(20, 140)
    .setSize(200, 19)
    .setFont(font) 
    .setValue(0);

  cp5.addKnob("Regler")
    .setRange(0, 255)
    .setValue(50)
    .setPosition(220, 50)
    .setRadius(50)
    .setDragDirection(Knob.VERTICAL);

  cp5.addColorPicker("Farbauswahl")
    .setPosition(20, 190)
    .setFont(font)
    .setColorValue(color(255, 128, 0, 128));

  d1 = cp5.addDropdownList("Liste")
    .setPosition(20, 280)
    .setSize(200, 25)
    .setFont(font)
    .setBackgroundColor(color(190))
    .setItemHeight(22)
    .setBarHeight(15)
    //.scroll(0)
    .setColorBackground(color(60))
    .setColorActive(color(255, 128));

  customize(d1);
}

void draw() {
}

///////////////////////////////////////////////////////////
// gibt alle Events aus
///////////////////////////////////////////////////////////

public void controlEvent(ControlEvent theEvent) {
  print("Event ");
  // + theEvent.getController().getName()
}

///////////////////////////////////////////////////////////
// die Prozedur mit dem Namen "Wert" erhält
// Änderungen des Sliders "Wert"
///////////////////////////////////////////////////////////

public void Wert(float theValue) {
  println("Wert: " + theValue);
}

///////////////////////////////////////////////////////////
// die Prozedur mit dem Namen "Button1" erhält
// Änderungen des Buttons "Button1"
///////////////////////////////////////////////////////////

public void Button1(int theValue) {
  println("Button1 wurde gedrückt: ");
}

///////////////////////////////////////////////////////////
// die Prozedur mit dem Namen "Regler" erhält
// Änderungen des Drehreglers "Regler"
///////////////////////////////////////////////////////////

public void Regler(float theValue) {
  println("Regler: " + theValue);
}

///////////////////////////////////////////////////////////
// die Prozedur mit dem Namen "Farbauswahl" erhält
// Änderungen des Farbauswahl-Dialogs
///////////////////////////////////////////////////////////

public void Farbauswahl(color theValue) {
  println("Farbe: (" + red(theValue) + "," + green(theValue) + "," + blue(theValue) + ")");
}

///////////////////////////////////////////////////////////
// erlaubt die Veränderung der Attribute einer
// dropdown-Liste
///////////////////////////////////////////////////////////

void customize(DropdownList ddl) {
  // a convenience function to customize a DropdownList
  ddl.addItem("Listeneintrag1", 1);
  ddl.addItem("Listeneintrag2", 2);
  ddl.addItem("Listeneintrag3", 3);
}